#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime:    2021/6/19 9:47
@LastEditTime:
@Description: 获取自动投喂的配置信息，默认有10条数据，全部查询
"""

from abstract_api import AbstractApi
from event_storage import EventStorage


class GetFeedingCurve(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()
        # 1号供料器频率：c659，2号供料器频率：c663，3号供料器频率：c667
        list = ["c659", "c663", "c667"]
        real_data_dict = operate_mysql.get_real_data(list)
        feeder_frequency = self.str_to_flaot(real_data_dict['c659']) + self.str_to_flaot(
            real_data_dict['c663']) + self.str_to_flaot(real_data_dict['c667'])
        if feeder_frequency >= 0:
            sql = "SELECT SUM(feeding_amount) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data);"
            feeding_amount = operate_mysql.execute_sql(sql)

            sql = "SELECT times,feeder_frequency FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data);"
            datas = operate_mysql.execute_sql(sql)
            if datas is not None:
                if len(datas) != 0:
                    dict_each = {}
                    times = []
                    feeder_frequencys = []
                    dict_each['feeding_amount'] = round(feeding_amount[0]['SUM(feeding_amount)'],2)
                    for each in datas:
                        times.append(each['times'])
                        feeder_frequencys.append(each['feeder_frequency'])
                    dict_each['times'] = times
                    dict_each['datas'] = feeder_frequencys
                    return dict_each
                else:
                    return None
            else:
                return "查询出错，请看日志"
        else:
            return None

    def str_to_flaot(self, str):
        if str != None:
            return float(str)
        else:
            return 0
