#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2021/9/24 11:12
@Author: lxc
@LastEditTime: 
@Desctiption: 更新水下设备的下次清洗时间
"""


from abstract_api import AbstractApi
from event_storage import EventStorage
from datetime import datetime, timedelta

class UpdateUnderwaterEquipCleanTime(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()
        device_name = request["device_name"]
        status = request["status"]
        if device_name == "all":
            # 修改设备清洗提示功能的弹窗弹窗状态
            update_sql = f"UPDATE underwater_equipment_clean SET function_status={status};"

        else:
            # 修改设备的下次清洗时间
            select_sql = "SELECT clean_cycle,next_clean_time FROM underwater_equipment_clean WHERE device_name=\'%s\';" % (device_name)
            device_info = operate_mysql.execute_sql(select_sql)[0]
            if status == 1:
                # 设备已清洗，修改本次清洗时间、下次清洗时间
                this_clean_time = datetime.now()
                clean_cycle = device_info["clean_cycle"]
                next_clean_time = (this_clean_time+timedelta(days=clean_cycle)).strftime("%Y-%m-%d %H:%M:%S")
                update_sql = "UPDATE underwater_equipment_clean SET this_clean_time=\'%s\',next_clean_time=\'%s\' WHERE device_name=\'%s\';" % (this_clean_time.strftime("%Y-%m-%d %H:%M:%S"), next_clean_time, device_name)

            elif status == 0:
                # 设备未清洗，4h后再次提示
                next_clean_time = (datetime.now()+timedelta(hours=4)).strftime("%Y-%m-%d %H:%M:%S")
                update_sql = "UPDATE underwater_equipment_clean SET next_clean_time=\'%s\' WHERE device_name=\'%s\'" % (next_clean_time, device_name)

        res = operate_mysql.execute_sql(update_sql)

