#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/06/30 11:01
@Author: lxc
@LastEditTime:
@Desctiption:
"""


from converter import Converter
import struct
import binascii
from log import OutPutLog
from event_storage import EventStorage


class TcpConverter(Converter):
    list = []

    def __init__(self):
        self._log = OutPutLog()
        self._storage = EventStorage()


    def convert(self, config, data):
        """
        :param config: [{'id': 27, 'station_name': 'modbustcptest' ...}, {'id': 28, 'station_name': 'modbustcptest' ...} ..]
        :param data: b'\xaa\x88\x00\x00\x01\x00U'
        :return: {'c201': 0, 'c202': 1, 'c203': 2, 'c204': 3, 'c205': 4, 'c206': 5 ...}
        """
        # print(config)
        # print(data)
        if data:
            format_data_dict = {}  # 列表数据转换字典数字
            try:
                # print(len(data), "data = ", data)
                for index in config:
                    # addr_type : 'D' 或 'X';
                    # addr_list: [10] 或 [10, 5]
                    addr_type, addr_list = addr_parsing(index['address'])
                    register_addr = addr_list[0]  # 数据地址  example:'X10.5' -> 10

                    if len(data) > register_addr:
                        if addr_type == 'D':
                            if index['data_type'] == "INT16":
                                return_data = data[register_addr]

                            # # 先乘除
                            # if index['divisor'] is not None:
                            #     return_data = return_data * index['divisor']
                            # # 再加减
                            # if index['offset'] is not None:
                            #     return_data = return_data + index['offset']

                            if isinstance(return_data, float):
                                return_data = round(return_data, 2)
                        name = 'c' + str(index['serial_number'])
                        format_data_dict[name] = return_data
                # print("format_data_dict = ", format_data_dict)
                return format_data_dict
            except Exception as e:
                print("e = ", e)
                self._log.error(e)
                return "error"


def addr_parsing(addr_smash):
    """
    :param addr_smash: [X15.1] or [D15]
    :return: X, [15, 1] or D [15]
    """
    # addr_smash_1 = 'D2'
    # addr_smash = list(addr_smash)  # 拆分字符串为list ['X', '6', '.', '2']
    addr_type = addr_smash[0]  # 地址类型 : 'D' 或 'X'
    addr_smash = addr_smash[1:]  # 地址部分: '10' 或 '10.5'
    addr_list = list(map(int, addr_smash.split(".")))  # 用“.”分割字符串转换为整型存入列表
    return addr_type, addr_list
