#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/06/21 14:42
@Author: lxc
@LastEditTime:
@Desctiption: 报警页面的配置子页面：修改上限和下限
"""

from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog


class AlarmChangeLimit(AbstractApi):
    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()
        # serial_number = request['serial_number'].replace('c', '')
        serial_number = request['serial_number']
        alarm_low_limit = request['alarm_low_limit']
        alarm_up_limit = request['alarm_up_limit']

        sql_change = "UPDATE data_point_tbl SET alarm_low_limit=%s, alarm_up_limit=%s WHERE serial_number=%s" % (alarm_low_limit, alarm_up_limit, serial_number)
        try:
            result = operate_mysql.execute_update_sql(sql_change)
        except Exception as e:
            self._log.error(e)
            result = False

        return result