#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/06/20 15:59
@Author: lxc
@LastEditTime:
@Desctiption: 蜂鸣器报警消音、开关蜂鸣器、开关报警弹框、设置报警弹框间隔时间
"""

from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog


class AlarmCloseBuzzer(AbstractApi):
    """蜂鸣器消音、开关蜂鸣器"""
    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()

        if "buzzer_operate" in request.keys():
            operate = request["buzzer_operate"]        # closeBuzzer：关闭蜂鸣器，openBuzzer，开启蜂鸣器

            if operate == "closeBuzzer":
                update_sql = "UPDATE alarm_set SET buzzer_status=0;"

            elif operate == "openBuzzer":
                update_sql = "UPDATE alarm_set SET buzzer_status=1;"

        elif "alarm_pop" in request.keys():
            # 是否开启报警弹框提示，0=关闭，1=开启
            alarm_pop = request['alarm_pop']
            update_sql = f"UPDATE alarm_set SET alarm_pop={alarm_pop}"

        elif "alarm_pop_period" in request.keys():
            # 设置报警弹框间隔时间，单位：s
            alarm_pop_period = request['alarm_pop_period']
            update_sql = f"UPDATE alarm_set SET alarm_pop_period={alarm_pop_period}"

        elif "alarm_cancel" in request.keys():
            # 设置报警消息的状态为已读
            id = request['alarm_cancel']['id']
            if len(id) == 1:
                update_sql = f"UPDATE alarm_tbl SET is_cancel=1 WHERE id={id[0]}"
            else:
                update_sql = f"UPDATE alarm_tbl SET is_cancel=1 WHERE id in {format(tuple(id))}"


        if update_sql:
            result = operate_mysql.execute_sql(update_sql)
        else:
            result = False

        return result
