#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/06/21 14:42
@Author: lxc
@LastEditTime: 
@Desctiption: 报警页面：获取历史报警信息
"""
import time

from abstract_api import AbstractApi
from event_storage import EventStorage

class AlarmGetData(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()
        device_name = request["device_name"]

        # 查看点表中所有需要查看的点
        if device_name == "all_device":
            get_data_point_tbl = "SELECT serial_number,device_name,io_point_name,alarm_low_limit,alarm_up_limit FROM data_point_tbl;"
        else:
            get_data_point_tbl = f"SELECT serial_number,device_name,io_point_name,alarm_low_limit,alarm_up_limit FROM data_point_tbl WHERE device_name=\'{device_name}\';"

        data_point_info = operate_mysql.execute_sql(get_data_point_tbl)
        # all_point_info = {'c365': {'device_name': 'moxa_e1210', 'io_point_name': '主配电板绝缘低', 'alarm_low_limit': 0.0, 'alarm_up_limit': 1.0}, ...}
        all_point_info = {}
        device_name_list = []
        for each in data_point_info:
            device_name_list.append(each["device_name"])
            serial_number = "c"+str(each["serial_number"])
            del each["serial_number"]
            all_point_info[serial_number] = each


        # 查看报警记录表中对应的报警信息
        if request["alarm_point_status"] == 0:
            # 查看实时报警信息
            get_alarm_sql = "SELECT id, CAST(create_time AS CHAR) AS create_time,point_name,data,is_cancel,signal_type FROM alarm_tbl WHERE alarm_point_status=0 ORDER BY `create_time` DESC;"
        elif request["alarm_point_status"] == 1:
            # 查询历史报警信息
            time_begin = request["time_begin"]
            time_end = request["time_end"]
            get_alarm_sql = f"SELECT id, CAST(create_time AS CHAR) AS create_time,point_name,data,is_cancel,signal_type " \
                            f"FROM alarm_tbl WHERE alarm_point_status=1 and create_time BETWEEN '{time_begin}' AND '{time_end}' ORDER BY `create_time` DESC;"


        get_alarm_info = operate_mysql.execute_sql(get_alarm_sql)
        alarm_list = []
        for alarm in get_alarm_info:
            # alarm = {'create_time': '2022-06-17 14:21:10', 'point_name': 'c3', 'data': 70.0, 'is_cancel': 0, 'signal_type': 'Analog'}
            point_name = alarm["point_name"]
            if point_name in all_point_info.keys():
                point_info = all_point_info[point_name]
                del alarm["point_name"]
                alarm_list.append(dict(alarm, **point_info))
            else:
                signal_type = alarm["signal_type"]
                if signal_type == "device_clean":
                    # 水下设备清洗的报警提示
                    alarm["device_name"] = signal_type
                    alarm["io_point_name"] = alarm["point_name"]
                    del alarm["point_name"]
                    alarm["alarm_low_limit"] = None
                    alarm["alarm_up_limit"] = None

                    device_name_list.append(signal_type)
                    alarm_list.append(alarm)

        get_alarm_status = "SELECT buzzer_status,alarm_pop,alarm_pop_period FROM `alarm_set`;"
        get_alarm_status = operate_mysql.execute_sql(get_alarm_status)      # 获取蜂鸣器报警功能是否开启、报警弹框是否开启、报警弹框间隔时间（s）

        res = {
            "buzzer_status": get_alarm_status[0]['buzzer_status'],
            "alarm_pop": get_alarm_status[0]['alarm_pop'],
            "alarm_pop_period": get_alarm_status[0]['alarm_pop_period'],
            "device_name": list(set(device_name_list)),
            "alarm_info": alarm_list
        }
        return res

