#!/usr/bin/env python
# encoding: utf-8
"""
@time: 2021/5/31 17:55
@desc: 水质监测系统：修改上限和下限
"""

from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog

class ChangeAlarmLimit(AbstractApi):
    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()
        serial_number = request['serial_number'].replace('c', '')
        alarm_low_limit = request['alarm_low_limit']
        alarm_up_limit = request['alarm_up_limit']

        sql_change = "UPDATE data_point_tbl SET alarm_low_limit=%s, alarm_up_limit=%s WHERE serial_number=%s" % (alarm_low_limit, alarm_up_limit, serial_number)
        try:
            operate_mysql.execute_sql(sql_change)
            return "change success"
        except Exception as e:
            self._log.error(str(e))
            return "change failed"