#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2021/11/29 17:18
@Author: lxc
@LastEditTime: 
@Desctiption:水下聚鱼灯远程控制功能：修改控制模式
"""

import json
from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog


class GatherFishLightChangeMode(AbstractApi):
    """修改聚鱼灯的控制模式及相关信息"""

    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()
        location = request["location"]
        control_mode = request["control_mode"]

        sql = f"UPDATE gather_fish_light_control SET control_mode={control_mode}"

        if control_mode == 0:
            # 光敏控制模式
            pass
        elif control_mode == 1:
            # 手动控制模式
            light_status = request["status"]
            sql = f"{sql}, status={light_status}"
        elif control_mode == 2:
            # 定时控制模式
            definite_time = json.dumps(request["definite_time"])
            sql = f"{sql}, definite_time=\'{definite_time}\'"

        sql = f"{sql} WHERE location=\'{location}\';"
        res = operate_mysql.execute_update_sql(sql)
        if res is False:
            self._log.error(f"聚鱼灯控制模式修改失败！{sql}")


        return res
