#!/usr/bin/env python
# encoding: utf-8
"""
@time: 2021/5/25 11:21
@desc: 返回所有设备的维保信息
"""

from abstract_api import AbstractApi
from event_storage import EventStorage


class GetMaintenanceInfo(AbstractApi):
    """返回设备的维保信息"""
    def operation(self, request):
        operate_mysql = EventStorage()

        # 返回维保信息
        return_data = []
        sql = "SELECT * FROM maintenance_information ORDER BY id;"
        res = operate_mysql.execute_sql(sql)
        for each_data in res:
            res_dict = {"device_name": each_data['device_name'],
                        "day_energy": each_data['day_energy'],
                        "day_energy_percent": each_data['day_energy_percent'],
                        "month_energy": each_data['month_energy'],
                        "month_energy_percent": each_data['month_energy_percent'],
                        "run_time": each_data['run_time'],
                        "maintenance_cycle": each_data['maintenance_cycle'],
                        "last_maintenance_time": (each_data['last_maintenance_time']).strftime('%Y-%m-%d %H:%M'),
                        "waiting_days": each_data['waiting_days']}
            return_data.append(res_dict)
        return return_data
